var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup",function(evt){
        evt.preventDefault();
        evt.stopPropagation();
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
        mouseButtonPressed=noMouseButtonPressed;
    });

    $("#visualisation").on("mousedown",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        mouseButtonPressed=evt.button;
        handleMouseDown();
    });

    $(document).contextmenu(function(){
        return false;
    });
    
    window.addEventListener("beforeunload",function(e){
    	resetSimulation();
    });
}

function initialiseGUI(){
	loadPencilImages();
	initialisePencils();
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+30;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
    
    pencilsTop=TopPanelHeight+10;
}

function showNextStepButton(){
	return (introStep<introLastStep);
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    // Φόντα οθόνης
    drawIntroImage();
	if(introStep==introSimStep){
		drawSet();
	}
    drawPanels();
    drawLogoImage();
    if(introStep==introSimStep){
        $("#controlsDIV").show();
    }
    else{
        $("#controlsDIV").hide();
    }
    showUserPrompts();
}

function drawIntroImage(){
    Intro=document.getElementById("img"+introStep);
    picTop=(height-Intro.height)/2;
    cntx.drawImage(Intro,1,picTop);
}

function drawPanels(){
    var lowRectTop=picTop+Intro.height+1;
    cntx.clearRect(0,0,width,picTop-1);
    cntx.clearRect(0,lowRectTop,width,height-lowRectTop);
    cntx.strokeStyle="black";
    cntx.beginPath();
    // πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    // άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    // κάτω πλαίσιο
    cntx.rect(0,lowRectTop,width,height-lowRectTop);
    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    if(showNextStepButton()) drawButtonNext();
    if(introStep>1) drawButtonBack();
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+5;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    // Διαχείριση κουμπιού [Επόμενο Βήμα]
    if(buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if(mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else{
        return false;
    }
}

function drawButtonBack(){
    // Διαχείριση κουμπιού [Επόμενο Βήμα]
    if(buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if(mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else{
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
	if(introStep==introSimStep){
		checkPencilHover();
		if(my>TopPanelHeight && my<BottomPanelTop && pencilHover>-1){
			canvas.style.cursor="pointer";
			draggingPencil=true;
			pencilToDrag=pencilHover;
			dDragX=mx-pencil[pencilToDrag][1];
			dDragY=my-pencil[pencilToDrag][2];
		}
		else{
			pencilToDrag=-1;
		}
	}
    drawBasicScreen();
}

function handleMouseMove(){
	canvas.style.cursor="default";
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
	if(mx>=clickHereLeft && mx<=clickHereRight && my>=550 && my<=560 && introStep<introSimStep){
		canvas.style.cursor="pointer";
	}
	if(introStep==introSimStep){
		if(pencilToDrag>-1){ //Move						
			pencil[pencilToDrag][1]=mx-dDragX;
			pencil[pencilToDrag][2]=my-dDragY;
			checkPencilHover();
		}
		else{
			checkPencilHover();
			if(pencilHover>-1){
				canvas.style.cursor="pointer";
			}
		}
	}
    if(!solving) drawBasicScreen();
}

function handleMouseUp(){
	draggingShape=false;
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<introLastStep && !solving){
        introStep++;
		if(introStep==introSimStep) {
			solving=false;
			initialisePencils();
		}
    }
    else if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1 && !solving){
        introStep--;
    }
	else if(mx>=clickHereLeft && mx<=clickHereRight && my>=550 && my<=560 && introStep<introSimStep){
		introStep=introSimStep;
	}
    
	if(introStep==introSimStep && pencilToDrag>-1){
	    checkPencilHover();
		if(pencilHover>-1 && pencilHover==pencilToDrag-1){
			pencil[pencilToDrag][1]=farLeft+pencilToDrag*slotWidth;
			temp=pencil[pencilToDrag][0];
			pencil[pencilToDrag][0]=pencil[pencilHover][0];
			pencil[pencilHover][0]=temp;
		}
		else{
		    pencil[pencilToDrag][1]=farLeft+slotWidth*pencilToDrag;//επαναφορά στην αρχική θεση
		}
		pencil[pencilToDrag][2]=pencilsTop;				
		draggingPencil=false;
		pencilToDrag=-1;
		pencilHover=-1;
	}
    
    drawBasicScreen();
}

function showUserPrompts(){
    var vTxtOffset=15;
    var hTxtOffset=BackStepLeft+BackStepWidth+border;
    var promptYCoord;
	if(introStep<introSimStep){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Αν θες να προσπεράσεις το κόμικ κάνε κλικ ΕΔΩ.");
	}
	else if(introStep==introSimStep){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Χρησιμοποίησε το ποντίκι για να σύρεις το μολύβι που νομίζεις ότι πρέπει να μετακινηθεί.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Μόλις το αφήσεις πάνω από κάποιο άλλο, τα δύο μολύβια θα αλλάξουν θέσεις.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Αν δεν τα καταφέρεις μπορείς να χρησιμοποιήσεις το κουμπί [Λύση].");
    }
}

function actionPerformed(btnSlctr){
    if(btnSlctr=="btnRestart"){
		resetPencils();
		solving=false;
    }
    else if(btnSlctr=="btnNewGame"){
		initialisePencils();
    }
    else if(btnSlctr=="btnSolution"){
		$("#btnRestart").prop("disabled",true);
		$("#btnNewGame").prop("disabled",true);
		$("#btnSolution").prop("disabled",true);
		$("#chkMovePencils").prop("disabled",true);
		$("#HscrDelay").prop("disabled",true);
		$("#btnStop").prop("disabled",false);
		initialiseSimulation();
    }
    else if(btnSlctr=="btnStop"){
    	resetSimulation();
    }
	pencilToDrag=-1;
    drawBasicScreen();
}

function itemStateChanged(slctr){
    if(slctr=="chkMarking"){

    }
    drawBasicScreen();
}

function initialiseSimulation(){
	iSolve=1;
	jSolve=noOfPencils-1;
	solving=true;
	rangeValueChanged("HscrDelay");
    timerLoop=setInterval(function(){run();},simulationSpeed);	
}

function resetSimulation(){
	clearInterval(timerLoop);
	solving=false;
	$("#chkMovePencils").prop("disabled",false);
	$("#btnRestart").prop("disabled",false);
	$("#btnNewGame").prop("disabled",false);
	$("#btnSolution").prop("disabled",false);
	$("#HscrDelay").prop("disabled",false);
	$("#btnStop").prop("disabled",true);
}

function rangeValueChanged(slctr){
    if(slctr=="HscrDelay"){
        $("#lblDelay").text(parseInt($("#HscrDelay").val()));
        simulationSpeed=5*parseInt($("#HscrDelay").val());
    }
}

function run(){
	var temp,k,kMax;
	if(solving){
		if(pencilsMoving){
			if(movingStep==noOfMovingSteps){
				if($("#chkMovePencils").prop("checked")){
					kMax=3;
				}
				else{
					kMax=1;
				}
				pencilsMoving=false;
				for(k=0;k<kMax;k++){
					temp=pencil[jSolve][k];						
					pencil[jSolve][k]=pencil[jSolve-1][k];						
					pencil[jSolve-1][k]=temp;
				}
				swapPerformed=true;						
				jSolve--;
			}
			else{
				if(movingStep<noOfVerticalSteps){
					pencil[jSolve][2]=pencil[jSolve][2]+1;
					pencil[jSolve-1][2]=pencil[jSolve-1][2]-1;
				}
				else if(movingStep<noOfVerticalSteps+slotWidth){
					pencil[jSolve][1]=pencil[jSolve][1]-1;
					pencil[jSolve-1][1]=pencil[jSolve-1][1]+1;							
				}
				else{
					pencil[jSolve][2]=pencil[jSolve][2]-1;
					pencil[jSolve-1][2]=pencil[jSolve-1][2]+1;							
				}
				movingStep++;						
			}
		}
		else if(iSolve==noOfPencils){
			resetSimulation();
		}
		else if(jSolve<iSolve){
			if (!swapPerformed){
				iSolve=noOfPencils;
			}
			else{
				iSolve++;
				jSolve=noOfPencils-1;
				swapPerformed=false;					
			}
		}
		else{
			if(pencil[jSolve][0]<pencil[jSolve-1][0]){
				if($("#chkMovePencils").prop("checked")){
					movingStep=0;
				}
				else{
					movingStep=noOfMovingSteps;
				}
				pencilsMoving=true;
			}
			else{
				jSolve--;
			}
		}
		drawBasicScreen();
	}
}

function checkPencilHover(){
	var i=noOfPencils-1,pnc=-1;
	while(i>-1 && pnc==-1){
		if(pncHover(i)){
			if(pencilToDrag==-1){
				pnc=i;
			}
			else{
				if(pencilToDrag!=i){
					pnc=i;
				}
			}
		}
		i--;
	}
	pencilHover=pnc;
}

function pncHover(i){
	var flag=false;
	var pHeight=pHeightFront+pHeightRear+pencil[i][0]*pHeightMiddle;
	if(mx>farLeft+slotWidth*i && mx<farLeft+slotWidth*(i+1) && my>pencil[i][2] && my<pencil[i][2]+pHeight){
		flag=true;
	}
	return flag;
}

function loadPencilImages(){
	pFront=document.getElementById("pfront");
	pMiddle=document.getElementById("pmiddle");
	pRear=document.getElementById("prear");
	pHeightFront=pFront.height;
	pWidth=pFront.width;
	slotWidth=pWidth+2;
	noOfMovingSteps=2*noOfVerticalSteps+slotWidth;
	pHeightMiddle=pMiddle.height;
	pHeightRear=pRear.height;
}

function initialisePencils(){
	var i,j,newHeight;
	var found;
	farLeft=slotWidth*8;
	for (i=0;i<noOfPencils;i++){
		do{
			found=false;
			newHeight=parseInt(Math.random()*baseSize)+4;
			j=0;
			while(j<i && !found){
				if(newHeight==pencil[j][0]) found=true; ;
				j++;
			}
		}while(found);
		pencil[i][3]=newHeight;
		pencil[i][1]=farLeft+slotWidth*i;
		pencil[i][2]=pencilsTop;
		pencil[i][0]=pencil[i][3];
	}
}

function resetPencils(){
	for(var i=0;i<noOfPencils;i++){
		pencil[i][0]=pencil[i][3];
	}
}

function drawSet(){
	for(var i=0;i<noOfPencils;i++){
		if(i!=pencilToDrag) drawPencil(i);			
	}
	if(pencilToDrag>-1) drawPencil(pencilToDrag);
}

function drawPencil(i){
	var j,yCoord;
	cntx.drawImage(pFront,pencil[i][1]-1,pencil[i][2]);
	yCoord=pencil[i][2]+pHeightFront;
	for(j=0;j<pencil[i][0];j++){
		cntx.drawImage(pMiddle,pencil[i][1],yCoord);
		yCoord=yCoord+pHeightMiddle;
	}
	cntx.drawImage(pRear,pencil[i][1],yCoord-1);
	if(solving && $("#chkMarking").prop("checked")){
		if(jSolve==i){
			cntx.strokeStyle="rgb(255,0,0)";
			cntx.beginPath();
			cntx.rect(pencil[i][1],pencil[i][2],pWidth,yCoord+pHeightRear-pencil[i][2]);
			cntx.stroke();
		}
		else if(jSolve-1==i && jSolve>0){
			cntx.strokeStyle="rgb(0,0,255)";
			cntx.beginPath();
			cntx.rect(pencil[i][1],pencil[i][2],pWidth,yCoord+pHeightRear-pencil[i][2]);
			cntx.stroke();
		}
	}
	else if(pencilHover>-1 && pencilHover==i){
		cntx.strokeStyle="rgb(0,0,0)";
		cntx.beginPath();
		cntx.rect(pencil[i][1],pencil[i][2],pWidth,yCoord+pHeightRear-pencil[i][2]);
		cntx.stroke();
	}
}